import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, InjectionToken, OnDestroy, Renderer2 } from '@angular/core';
export declare type NtDrawerPlacement = 'left' | 'right' | 'top' | 'bottom';
export interface NtDrawerContainer {
    readonly element: HTMLElement;
}
export declare const NT_DRAWER_CONTAINER: InjectionToken<NtDrawerContainer>;
export declare class NtDrawerComponent implements AfterViewInit, OnDestroy {
    private _element;
    private _changeDetectorRef;
    private _renderer;
    readonly id: string;
    private _destory;
    private _outsideClickSubscription;
    private _container;
    private _backdropElement;
    private _backdrop;
    backdrop: boolean;
    private _placement;
    placement: NtDrawerPlacement;
    private _opened;
    opened: boolean;
    openedChange: EventEmitter<any>;
    outsideClick: EventEmitter<any>;
    constructor(_element: ElementRef, _changeDetectorRef: ChangeDetectorRef, _renderer: Renderer2, platformId: Object, container: NtDrawerContainer);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    close(): void;
    /** 调整方向的样式属性 */
    private _changePlacementValueAndStyle;
    /** 设置容器的样式 */
    private _initContainerAndStyles;
    /** 创建遮罩层元素对象，当 backdrop 属性是 true 的时候才会创建 */
    private _createBackdropOverlay;
    /** 删除遮罩层元素对象，当 backdrop 属性是 false 时会执行这一操作 */
    private _removeBackdropOverlay;
    /** 将创建好的遮罩层添加到 区域元素内（默认为 body 元素） */
    private _attachBackdropOverlay;
    /** 将区域元素内（默认为 body 元素）的遮罩层移除 */
    private _disattachBackdropOverlay;
    /** 设置展开 */
    private _setOpenedValueAndEmit;
    /** 开始外部点击事件的订阅 */
    private _subscribeOutsideClickEvent;
    /** 取消外部点击事件的订阅 */
    private _unsubscribeOutsideClickEvent;
}
