import { CommonModule } from '@angular/common';
import { Input, Component, ViewEncapsulation, NgModule } from '@angular/core';

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtAvatarComponent = /** @class */ (function () {
    function NtAvatarComponent() {
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated > 0.6.0
         */
        this.class = '';
        this.size = '';
        this._shape = 'square';
        this.src = '';
        this.alt = '';
    }
    Object.defineProperty(NtAvatarComponent.prototype, "shape", {
        get: function () { return this._shape; },
        set: function (value) {
            value === 'circle' && (this._shape = value);
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Input()
    ], NtAvatarComponent.prototype, "class", void 0);
    __decorate([
        Input()
    ], NtAvatarComponent.prototype, "size", void 0);
    __decorate([
        Input()
    ], NtAvatarComponent.prototype, "shape", null);
    __decorate([
        Input()
    ], NtAvatarComponent.prototype, "src", void 0);
    __decorate([
        Input()
    ], NtAvatarComponent.prototype, "alt", void 0);
    NtAvatarComponent = __decorate([
        Component({
            selector: 'nt-avatar',
            template: '<img [src]="src" [alt]="alt">',
            encapsulation: ViewEncapsulation.None,
            host: {
                '[class]': '["nt-avatar", size, shape, class].join(" ")',
                '[class.nt-avatar-circle]': 'shape == "circle"',
            }
        })
    ], NtAvatarComponent);
    return NtAvatarComponent;
}());

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtAvatarModule = /** @class */ (function () {
    function NtAvatarModule() {
    }
    NtAvatarModule = __decorate$1([
        NgModule({
            imports: [CommonModule],
            declarations: [NtAvatarComponent],
            exports: [NtAvatarComponent]
        })
    ], NtAvatarModule);
    return NtAvatarModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { NtAvatarComponent, NtAvatarModule };
//# sourceMappingURL=avatar.js.map
