import { isPlatformBrowser, CommonModule } from '@angular/common';
import { Inject, PLATFORM_ID, ElementRef, Renderer2, Input, Component, ViewEncapsulation, NgModule } from '@angular/core';

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var NtBadgeComponent = /** @class */ (function () {
    function NtBadgeComponent(platformId, _elementRef, _renderer) {
        this.platformId = platformId;
        this._elementRef = _elementRef;
        this._renderer = _renderer;
        this._type = 'static';
        this.color = '';
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated > 0.6.0
         */
        this.class = '';
    }
    Object.defineProperty(NtBadgeComponent.prototype, "type", {
        get: function () { return this._type; },
        set: function (value) {
            if (value === 'float' || value === 'notify') {
                this._resetPosition();
            }
            else {
                this._clearPosition();
            }
            this._type = value;
        },
        enumerable: true,
        configurable: true
    });
    NtBadgeComponent.prototype.ngAfterViewInit = function () {
        this._resetPosition();
    };
    NtBadgeComponent.prototype.ngOnDestroy = function () {
        this._clearPosition();
    };
    // 重置容器的 position 属性
    NtBadgeComponent.prototype._resetPosition = function () {
        if (isPlatformBrowser(this.platformId)) {
            var style = window.getComputedStyle(this._elementRef.nativeElement.parentElement);
            if (style.position !== 'absolute' || style.position !== 'absolute') {
                this._originalPosition = style.position;
                this._renderer.setStyle(this._elementRef.nativeElement.parentElement, 'position', 'relative');
            }
        }
    };
    // 清理 position 属性
    NtBadgeComponent.prototype._clearPosition = function () {
        if (isPlatformBrowser(this.platformId)) {
            if (this._originalPosition) {
                this._renderer.removeStyle(this._elementRef.nativeElement.parentElement, 'position');
            }
        }
    };
    NtBadgeComponent.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] },
        { type: ElementRef },
        { type: Renderer2 }
    ]; };
    __decorate([
        Input()
    ], NtBadgeComponent.prototype, "color", void 0);
    __decorate([
        Input()
    ], NtBadgeComponent.prototype, "class", void 0);
    __decorate([
        Input()
    ], NtBadgeComponent.prototype, "type", null);
    NtBadgeComponent = __decorate([
        Component({
            selector: 'nt-badge, [nt-badge]',
            template: "<ng-content></ng-content>",
            encapsulation: ViewEncapsulation.None,
            host: {
                '[class]': '["badge", color, class].join(" ")',
                '[class.badge-float]': 'type === "float"',
                '[class.badge-notify]': 'type === "notify"'
            }
        }),
        __param(0, Inject(PLATFORM_ID))
    ], NtBadgeComponent);
    return NtBadgeComponent;
}());

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtBadgeModule = /** @class */ (function () {
    function NtBadgeModule() {
    }
    NtBadgeModule = __decorate$1([
        NgModule({
            imports: [CommonModule],
            declarations: [NtBadgeComponent],
            exports: [NtBadgeComponent]
        })
    ], NtBadgeModule);
    return NtBadgeModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { NtBadgeComponent, NtBadgeModule };
//# sourceMappingURL=badge.js.map
